<?
  class Database
  {
    private $db;
    private static $instance = null;
      
    public static function get_instance()
    {
      if (self::$instance == null)
        self::$instance = new Database();
      
      return self::$instance;
    }
    
    private function Database()
    {
      $db_file = 'database/database.sqlite';
      
      if (! file_exists($db_file))
      {
        $this->db = new PDO('sqlite:'. $db_file);
        
        $this->db->query('CREATE TABLE Test
                          (id INTEGER PRIMARY KEY,
                           editId INTEGER,
                           testId INTEGER,
                           title TEXT,
                           questions TEXT,
                           answers TEXT)');
      }
      else
      {
        $this->db = new PDO('sqlite:'. $db_file);
      }
    }
    
    function update_test($editId, $title, $questions, $answers)
    {
      $statement =
        $this->db->prepare('UPDATE Test
                              set title = ?,
                                  questions = ?,
                                  answers = ?
                            WHERE editId = ?');
      
      $statement->execute(array($title, $questions, $answers, $editId));
    }
    
    function get_test_by_editId($editId)
    {
      $statement = 
        $this->db->prepare('SELECT title, questions, answers, testId, editId
                            FROM Test
                            WHERE editId = ?');
      
      $statement->execute(array($editId));
      
      return $statement->fetch();
    }
    
    function get_test_by_testId($testId)
    {
      $statement = 
        $this->db->prepare('SELECT title, questions, answers
                            FROM Test
                            WHERE testId = ?');
      
      $statement->execute(array($testId));
      
      return $statement->fetch();
    }
    
    function create_test()
    {
      do
      {
        $editId = rand(10000, 99999);
      } while ($this->get_test_by_editId($editId));
      
      do
      {
        $testId = rand(10000, 99999);
      } while ($this->get_test_by_testId($testId));
      
      $statement =
        $this->db->prepare('INSERT INTO Test (editId, testId, title, questions, answers)
                            VALUES (?, ?, "", "", "")');
      
      $statement->execute(array($editId, $testId));
      
      return $editId;
    }
  }
?>
